Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 4901)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 1)
@@ -947,820 +473,222 @@
 !--          Subgridscale fluxes in the Prandtl layer
              IF ( use_surface_fluxes )  THEN
-                DO  l = 0, 1
-                   ! The original code using MERGE doesn't work with the PGI
-                   ! compiler when running on the GPU.
-                   ! This is submitted as a compiler Bug in PGI ticket TPR#26718
-                   ! ki = MERGE( -1, 0, l == 0 )
-                   ki = -1 + l
-                   IF ( surf_def_h(l)%ns >= 1 )  THEN
-                      DO  m = surf_def_h(l)%start_index(j,i),                                      &
-                              surf_def_h(l)%end_index(j,i)
-                         k = surf_def_h(l)%k(m)
-
-                         !$ACC ATOMIC
-                         sums_l(k+ki,12,tn) = sums_l(k+ki,12,tn) +                                 &
-                                              momentumflux_output_conversion(k+ki) *               &
-                                              surf_def_h(l)%usws(m) * rmask(j,i,sr)     ! w"u"
-                         !$ACC ATOMIC
-                         sums_l(k+ki,14,tn) = sums_l(k+ki,14,tn) +                                 &
-                                              momentumflux_output_conversion(k+ki) *               &
-                                              surf_def_h(l)%vsws(m) * rmask(j,i,sr)     ! w"v"
-                         !$ACC ATOMIC
-                         sums_l(k+ki,16,tn) = sums_l(k+ki,16,tn) +                                 &
-                                              heatflux_output_conversion(k+ki) *                   &
-                                              surf_def_h(l)%shf(m)  * rmask(j,i,sr)     ! w"pt"
-#if 0
-                         sums_l(k+ki,58,tn) = sums_l(k+ki,58,tn) +                                 &
-                                              0.0_wp * rmask(j,i,sr)                    ! u"pt"
-                         sums_l(k+ki,61,tn) = sums_l(k+ki,61,tn) +                                 &
-                                              0.0_wp * rmask(j,i,sr)                    ! v"pt"
-#endif
-#ifndef _OPENACC
-                         IF ( ocean_mode )  THEN
-                            sums_l(k+ki,65,tn) = sums_l(k+ki,65,tn) +                              &
-                                                 surf_def_h(l)%sasws(m) * rmask(j,i,sr)  ! w"sa"
-                         ENDIF
-                         IF ( humidity )  THEN
-                            sums_l(k+ki,48,tn) = sums_l(k+ki,48,tn) +                              &
-                                                 waterflux_output_conversion(k+ki) *               &
-                                                 surf_def_h(l)%qsws(m) * rmask(j,i,sr)  ! w"q" (w"qv")
-                            sums_l(k+ki,45,tn) = sums_l(k+ki,45,tn) +  (                           &
-                                                 ( 1.0_wp + 0.61_wp * q(k+ki,j,i) ) *              &
-                                                 surf_def_h(l)%shf(m) + 0.61_wp * pt(k+ki,j,i) *   &
-                                                 surf_def_h(l)%qsws(m) )                           &
-                                                 * heatflux_output_conversion(k+ki)
-                            IF ( cloud_droplets )  THEN
-                               sums_l(k+ki,45,tn) = sums_l(k+ki,45,tn) +      (                    &
-                                                    ( 1.0_wp + 0.61_wp * q(k+ki,j,i) -             &
-                                                      ql(k+ki,j,i) ) * surf_def_h(l)%shf(m) +      &
-                                                      0.61_wp * pt(k+ki,j,i)                       &
-                                                      * surf_def_h(l)%qsws(m) )                    &
-                                                    * heatflux_output_conversion(k+ki)
-                            ENDIF
-                            IF ( bulk_cloud_model )  THEN
-!
-!--                            Formula does not work if ql(k+ki) /= 0.0
-                               sums_l(k+ki,51,tn) = sums_l(k+ki,51,tn) +                           &
-                                                    waterflux_output_conversion(k+ki) *            &
-                                                    surf_def_h(l)%qsws(m) * rmask(j,i,sr) ! w"q" (w"qv")
-                            ENDIF
-                         ENDIF
-                         IF ( passive_scalar )  THEN
-                            sums_l(k+ki,117,tn) = sums_l(k+ki,117,tn) +                            &
-                                                  surf_def_h(l)%ssws(m) * rmask(j,i,sr) ! w"s"
-                         ENDIF
-#endif
-
-                      ENDDO
-
-                   ENDIF
-                   IF ( surf_lsm_h(l)%end_index(j,i) >= surf_lsm_h(l)%start_index(j,i) )  THEN
-                      m = surf_lsm_h(l)%start_index(j,i)
-                      !$ACC ATOMIC
-                      sums_l(nzb,12,tn) = sums_l(nzb,12,tn) +                                         &
-                                          momentumflux_output_conversion(nzb) *                       &
-                                          surf_lsm_h(l)%usws(m) * rmask(j,i,sr)     ! w"u"
-                      !$ACC ATOMIC
-                      sums_l(nzb,14,tn) = sums_l(nzb,14,tn) +                                         &
-                                          momentumflux_output_conversion(nzb) *                       &
-                                          surf_lsm_h(l)%vsws(m) * rmask(j,i,sr)     ! w"v"
-                      !$ACC ATOMIC
-                      sums_l(nzb,16,tn) = sums_l(nzb,16,tn) +                                         &
-                                          heatflux_output_conversion(nzb) *                           &
-                                          surf_lsm_h(l)%shf(m)  * rmask(j,i,sr)     ! w"pt"
-#if 0
-                      sums_l(nzb,58,tn) = sums_l(nzb,58,tn) +                                         &
-                                          0.0_wp * rmask(j,i,sr)        ! u"pt"
-                      sums_l(nzb,61,tn) = sums_l(nzb,61,tn) +                                         &
-                                          0.0_wp * rmask(j,i,sr)        ! v"pt"
-#endif
-#ifndef _OPENACC
-                      IF ( ocean_mode )  THEN
-                         sums_l(nzb,65,tn) = sums_l(nzb,65,tn) +                                      &
-                                             surf_lsm_h(l)%sasws(m) * rmask(j,i,sr)  ! w"sa"
-                      ENDIF
-                      IF ( humidity )  THEN
-                         sums_l(nzb,48,tn) = sums_l(nzb,48,tn) +                                      &
-                                             waterflux_output_conversion(nzb) *                       &
-                                             surf_lsm_h(l)%qsws(m) * rmask(j,i,sr)  ! w"q" (w"qv")
-                         sums_l(nzb,45,tn) = sums_l(nzb,45,tn) + (                                    &
-                                             ( 1.0_wp + 0.61_wp * q(nzb,j,i) ) * surf_lsm_h(l)%shf(m) +  &
-                                               0.61_wp * pt(nzb,j,i) * surf_lsm_h(l)%qsws(m) )           &
-                                             * heatflux_output_conversion(nzb)
-                         IF ( cloud_droplets )  THEN
-                            sums_l(nzb,45,tn) = sums_l(nzb,45,tn) + (                                 &
-                                                ( 1.0_wp + 0.61_wp * q(nzb,j,i) -                     &
-                                                  ql(nzb,j,i) ) * surf_lsm_h(l)%shf(m) +                 &
-                                                  0.61_wp * pt(nzb,j,i) * surf_lsm_h(l)%qsws(m) )        &
-                                                * heatflux_output_conversion(nzb)
-                         ENDIF
-                         IF ( bulk_cloud_model )  THEN
-!
-!--                         Formula does not work if ql(nzb) /= 0.0
-                            sums_l(nzb,51,tn) = sums_l(nzb,51,tn) +                                   &
-                                                waterflux_output_conversion(nzb) *                    &
-                                                surf_lsm_h(l)%qsws(m) * rmask(j,i,sr) ! w"q" (w"qv")
-                         ENDIF
-                      ENDIF
-                      IF ( passive_scalar )  THEN
-                         sums_l(nzb,117,tn) = sums_l(nzb,117,tn) +                                    &
-                                              surf_lsm_h(l)%ssws(m) * rmask(j,i,sr) ! w"s"
-                      ENDIF
-#endif
-
-                   ENDIF
-                   IF ( surf_usm_h(l)%end_index(j,i) >= surf_usm_h(l)%start_index(j,i) )  THEN
-                      m = surf_usm_h(l)%start_index(j,i)
-                      !$ACC ATOMIC
-                      sums_l(nzb,12,tn) = sums_l(nzb,12,tn) +                                         &
-                                          momentumflux_output_conversion(nzb) *                       &
-                                          surf_usm_h(l)%usws(m) * rmask(j,i,sr)                ! w"u"
-                      !$ACC ATOMIC
-                      sums_l(nzb,14,tn) = sums_l(nzb,14,tn) +                                         &
-                                          momentumflux_output_conversion(nzb) *                       &
-                                          surf_usm_h(l)%vsws(m) * rmask(j,i,sr)                ! w"v"
-                      !$ACC ATOMIC
-                      sums_l(nzb,16,tn) = sums_l(nzb,16,tn) +                                         &
-                                          heatflux_output_conversion(nzb) *                           &
-                                          surf_usm_h(l)%shf(m)  * rmask(j,i,sr)                ! w"pt"
-#if 0
-                      sums_l(nzb,58,tn) = sums_l(nzb,58,tn) + 0.0_wp * rmask(j,i,sr)        ! u"pt"
-                      sums_l(nzb,61,tn) = sums_l(nzb,61,tn) + 0.0_wp * rmask(j,i,sr)        ! v"pt"
-#endif
-#ifndef _OPENACC
-                      IF ( ocean_mode )  THEN
-                         sums_l(nzb,65,tn) = sums_l(nzb,65,tn) +                                      &
-                                             surf_usm_h(l)%sasws(m) * rmask(j,i,sr)            ! w"sa"
-                      ENDIF
-                      IF ( humidity )  THEN
-                         sums_l(nzb,48,tn) = sums_l(nzb,48,tn) +                                      &
-                                             waterflux_output_conversion(nzb) *                       &
-                                             surf_usm_h(l)%qsws(m) * rmask(j,i,sr)             ! w"q" (w"qv")
-                         sums_l(nzb,45,tn) = sums_l(nzb,45,tn) + (                                    &
-                                             ( 1.0_wp + 0.61_wp * q(nzb,j,i) ) *                      &
-                                             surf_usm_h(l)%shf(m) + 0.61_wp * pt(nzb,j,i) *              &
-                                             surf_usm_h(l)%qsws(m)  )                                    &
-                                             * heatflux_output_conversion(nzb)
-                         IF ( cloud_droplets )  THEN
-                            sums_l(nzb,45,tn) = sums_l(nzb,45,tn) + (                                 &
-                                                ( 1.0_wp + 0.61_wp * q(nzb,j,i) -                     &
-                                                 ql(nzb,j,i) ) * surf_usm_h(l)%shf(m) +                  &
-                                                 0.61_wp * pt(nzb,j,i) * surf_usm_h(l)%qsws(m) )         &
-                                                * heatflux_output_conversion(nzb)
-                         ENDIF
-                         IF ( bulk_cloud_model )  THEN
-!
-!--                         Formula does not work if ql(nzb) /= 0.0
-                            sums_l(nzb,51,tn) = sums_l(nzb,51,tn) +                                   &
-                                                waterflux_output_conversion(nzb) *                    &
-                                                surf_usm_h(l)%qsws(m) * rmask(j,i,sr)          ! w"q" (w"qv")
-                         ENDIF
-                      ENDIF
-                      IF ( passive_scalar )  THEN
-                         sums_l(nzb,117,tn) = sums_l(nzb,117,tn) +                                    &
-                                              surf_usm_h(l)%ssws(m) * rmask(j,i,sr)            ! w"s"
-                      ENDIF
-#endif
-
-                   ENDIF
-                ENDDO
-             ENDIF
-
-#ifndef _OPENACC
-             IF ( .NOT. neutral )  THEN
-                IF ( surf_def_h(0)%end_index(j,i) >= surf_def_h(0)%start_index(j,i) )  THEN
-                   m = surf_def_h(0)%start_index(j,i)
-                   sums_l(nzb,112,tn) = sums_l(nzb,112,tn) + surf_def_h(0)%ol(m) * rmask(j,i,sr) ! L
-                ENDIF
-                IF ( surf_lsm_h(0)%end_index(j,i) >= surf_lsm_h(0)%start_index(j,i) )  THEN
-                   m = surf_lsm_h(0)%start_index(j,i)
-                   sums_l(nzb,112,tn) = sums_l(nzb,112,tn) + surf_lsm_h(0)%ol(m)    * rmask(j,i,sr) ! L
-                ENDIF
-                IF ( surf_usm_h(0)%end_index(j,i) >= surf_usm_h(0)%start_index(j,i) )  THEN
-                   m = surf_usm_h(0)%start_index(j,i)
-                   sums_l(nzb,112,tn) = sums_l(nzb,112,tn) + surf_usm_h(0)%ol(m)    * rmask(j,i,sr) ! L
-                ENDIF
-             ENDIF
-
-             IF ( radiation )  THEN
-                IF ( surf_def_h(0)%end_index(j,i) >= surf_def_h(0)%start_index(j,i) )  THEN
-                   m = surf_def_h(0)%start_index(j,i)
-                   sums_l(nzb,99,tn)  = sums_l(nzb,99,tn)   +                                      &
-                                        surf_def_h(0)%rad_net(m)    * rmask(j,i,sr)
-                   sums_l(nzb,100,tn) = sums_l(nzb,100,tn)  +                                      &
-                                        surf_def_h(0)%rad_lw_in(m)  * rmask(j,i,sr)
-                   sums_l(nzb,101,tn) = sums_l(nzb,101,tn)  +                                      &
-                                        surf_def_h(0)%rad_lw_out(m) * rmask(j,i,sr)
-                   sums_l(nzb,102,tn) = sums_l(nzb,102,tn)  +                                      &
-                                        surf_def_h(0)%rad_sw_in(m)  * rmask(j,i,sr)
-                   sums_l(nzb,103,tn) = sums_l(nzb,103,tn)  +                                      &
-                                        surf_def_h(0)%rad_sw_out(m) * rmask(j,i,sr)
-                ENDIF
-                IF ( surf_lsm_h(0)%end_index(j,i) >= surf_lsm_h(0)%start_index(j,i) )  THEN
-                   m = surf_lsm_h(0)%start_index(j,i)
-                   sums_l(nzb,99,tn)  = sums_l(nzb,99,tn)   +                                      &
-                                        surf_lsm_h(0)%rad_net(m)    * rmask(j,i,sr)
-                   sums_l(nzb,100,tn) = sums_l(nzb,100,tn)  +                                      &
-                                        surf_lsm_h(0)%rad_lw_in(m)  * rmask(j,i,sr)
-                   sums_l(nzb,101,tn) = sums_l(nzb,101,tn)  +                                      &
-                                        surf_lsm_h(0)%rad_lw_out(m) * rmask(j,i,sr)
-                   sums_l(nzb,102,tn) = sums_l(nzb,102,tn)  +                                      &
-                                        surf_lsm_h(0)%rad_sw_in(m)  * rmask(j,i,sr)
-                   sums_l(nzb,103,tn) = sums_l(nzb,103,tn)  +                                      &
-                                        surf_lsm_h(0)%rad_sw_out(m) * rmask(j,i,sr)
-                ENDIF
-                IF ( surf_usm_h(0)%end_index(j,i) >= surf_usm_h(0)%start_index(j,i) )  THEN
-                   m = surf_usm_h(0)%start_index(j,i)
-                   sums_l(nzb,99,tn)  = sums_l(nzb,99,tn)   +                                      &
-                                        surf_usm_h(0)%rad_net(m)    * rmask(j,i,sr)
-                   sums_l(nzb,100,tn) = sums_l(nzb,100,tn)  +                                      &
-                                        surf_usm_h(0)%rad_lw_in(m)  * rmask(j,i,sr)
-                   sums_l(nzb,101,tn) = sums_l(nzb,101,tn)  +                                      &
-                                        surf_usm_h(0)%rad_lw_out(m) * rmask(j,i,sr)
-                   sums_l(nzb,102,tn) = sums_l(nzb,102,tn)  +                                      &
-                                        surf_usm_h(0)%rad_sw_in(m)  * rmask(j,i,sr)
-                   sums_l(nzb,103,tn) = sums_l(nzb,103,tn)  +                                      &
-                                        surf_usm_h(0)%rad_sw_out(m) * rmask(j,i,sr)
-                ENDIF
-
-#if defined ( __rrtmg )
-                IF ( radiation_scheme == 'rrtmg' )  THEN
-
-                   IF ( surf_def_h(0)%end_index(j,i) >= surf_def_h(0)%start_index(j,i) )  THEN
-                      m = surf_def_h(0)%start_index(j,i)
-                      sums_l(nzb,108,tn)  = sums_l(nzb,108,tn)  +                                  &
-                                            surf_def_h(0)%rrtm_aldif(m,0) * rmask(j,i,sr)
-                      sums_l(nzb,109,tn) = sums_l(nzb,109,tn)  +                                   &
-                                           surf_def_h(0)%rrtm_aldir(m,0) * rmask(j,i,sr)
-                      sums_l(nzb,110,tn) = sums_l(nzb,110,tn)  +                                   &
-                                           surf_def_h(0)%rrtm_asdif(m,0) * rmask(j,i,sr)
-                      sums_l(nzb,111,tn) = sums_l(nzb,111,tn)  +                                   &
-                                           surf_def_h(0)%rrtm_asdir(m,0) * rmask(j,i,sr)
-                   ENDIF
-                   IF ( surf_lsm_h(0)%end_index(j,i) >= surf_lsm_h(0)%start_index(j,i) )  THEN
-                      m = surf_lsm_h(0)%start_index(j,i)
-                      sums_l(nzb,108,tn)  = sums_l(nzb,108,tn)  +                                  &
-                                            SUM( surf_lsm_h(0)%frac(m,:) *                            &
-                                                 surf_lsm_h(0)%rrtm_aldif(m,:) ) * rmask(j,i,sr)
-                      sums_l(nzb,109,tn) = sums_l(nzb,109,tn)  +                                   &
-                                           SUM( surf_lsm_h(0)%frac(m,:) *                             &
-                                                surf_lsm_h(0)%rrtm_aldir(m,:) ) * rmask(j,i,sr)
-                      sums_l(nzb,110,tn) = sums_l(nzb,110,tn)  +                                   &
-                                           SUM( surf_lsm_h(0)%frac(m,:) *                             &
-                                                surf_lsm_h(0)%rrtm_asdif(m,:) ) * rmask(j,i,sr)
-                      sums_l(nzb,111,tn) = sums_l(nzb,111,tn)  +                                   &
-                                           SUM( surf_lsm_h(0)%frac(m,:) *                             &
-                                                surf_lsm_h(0)%rrtm_asdir(m,:) ) * rmask(j,i,sr)
-                   ENDIF
-                   IF ( surf_usm_h(0)%end_index(j,i) >= surf_usm_h(0)%start_index(j,i) )  THEN
-                      m = surf_usm_h(0)%start_index(j,i)
-                      sums_l(nzb,108,tn)  = sums_l(nzb,108,tn)  +                                  &
-                                            SUM( surf_usm_h(0)%frac(m,:) *                            &
-                                                 surf_usm_h(0)%rrtm_aldif(m,:) ) * rmask(j,i,sr)
-                      sums_l(nzb,109,tn) = sums_l(nzb,109,tn)  +                                   &
-                                           SUM( surf_usm_h(0)%frac(m,:) *                             &
-                                                surf_usm_h(0)%rrtm_aldir(m,:) ) * rmask(j,i,sr)
-                      sums_l(nzb,110,tn) = sums_l(nzb,110,tn)  +                                   &
-                                           SUM( surf_usm_h(0)%frac(m,:) *                             &
-                                                surf_usm_h(0)%rrtm_asdif(m,:) ) * rmask(j,i,sr)
-                      sums_l(nzb,111,tn) = sums_l(nzb,111,tn)  +                                   &
-                                           SUM( surf_usm_h(0)%frac(m,:) *                             &
-                                                surf_usm_h(0)%rrtm_asdir(m,:) ) * rmask(j,i,sr)
-                   ENDIF
-
-                ENDIF
-#endif
-             ENDIF
-#endif
-!
-!--          Subgridscale fluxes at the top surface
-             IF ( use_top_fluxes )  THEN
-                m = surf_def_h(2)%start_index(j,i)
-                !$ACC ATOMIC
-                sums_l(nzt,12,tn) = sums_l(nzt,12,tn) +                                            &
-                                    momentumflux_output_conversion(nzt) *                          &
-                                    surf_def_h(2)%usws(m) * rmask(j,i,sr)    ! w"u"
-                !$ACC ATOMIC
-                sums_l(nzt+1,12,tn) = sums_l(nzt+1,12,tn) +                                        &
-                                      momentumflux_output_conversion(nzt+1) *                      &
-                                      surf_def_h(2)%usws(m) * rmask(j,i,sr)  ! w"u"
-                !$ACC ATOMIC
-                sums_l(nzt,14,tn) = sums_l(nzt,14,tn) +                                            &
-                                    momentumflux_output_conversion(nzt) *                          &
-                                    surf_def_h(2)%vsws(m) * rmask(j,i,sr)    ! w"v"
-                !$ACC ATOMIC
-                sums_l(nzt+1,14,tn) = sums_l(nzt+1,14,tn) +                                        &
-                                      momentumflux_output_conversion(nzt+1) *                      &
-                                      surf_def_h(2)%vsws(m) * rmask(j,i,sr)  ! w"v"
-                !$ACC ATOMIC
-                sums_l(nzt,16,tn) = sums_l(nzt,16,tn) +                                            &
-                                    heatflux_output_conversion(nzt) *                              &
-                                    surf_def_h(2)%shf(m)  * rmask(j,i,sr)    ! w"pt"
-                !$ACC ATOMIC
-                sums_l(nzt+1,16,tn) = sums_l(nzt+1,16,tn) +                                        &
-                                      heatflux_output_conversion(nzt+1) *                          &
-                                      surf_def_h(2)%shf(m)  * rmask(j,i,sr)  ! w"pt"
-#if 0
-                sums_l(nzt:nzt+1,58,tn) = sums_l(nzt:nzt+1,58,tn) +                                &
-                                          0.0_wp * rmask(j,i,sr)             ! u"pt"
-                sums_l(nzt:nzt+1,61,tn) = sums_l(nzt:nzt+1,61,tn) +                                &
-                                          0.0_wp * rmask(j,i,sr)             ! v"pt"
-#endif
-#ifndef _OPENACC
-                IF ( ocean_mode )  THEN
-                   sums_l(nzt,65,tn) = sums_l(nzt,65,tn) + &
-                                       surf_def_h(2)%sasws(m) * rmask(j,i,sr)  ! w"sa"
-                ENDIF
-                IF ( humidity )  THEN
-                   sums_l(nzt,48,tn) = sums_l(nzt,48,tn) +                                         &
-                                       waterflux_output_conversion(nzt) *                          &
-                                       surf_def_h(2)%qsws(m) * rmask(j,i,sr) ! w"q" (w"qv")
-                   sums_l(nzt,45,tn) = sums_l(nzt,45,tn) +   (                                     &
-                                       ( 1.0_wp + 0.61_wp * q(nzt,j,i) ) *                         &
-                                       surf_def_h(2)%shf(m) +                                      &
-                                       0.61_wp * pt(nzt,j,i) *                                     &
-                                       surf_def_h(2)%qsws(m) )                                     &
-                                       * heatflux_output_conversion(nzt)
-                   IF ( cloud_droplets )  THEN
-                      sums_l(nzt,45,tn) = sums_l(nzt,45,tn) +    (                                 &
-                                          ( 1.0_wp + 0.61_wp * q(nzt,j,i) -                        &
-                                            ql(nzt,j,i) ) *                                        &
-                                            surf_def_h(2)%shf(m) +                                 &
-                                           0.61_wp * pt(nzt,j,i) *                                 &
-                                           surf_def_h(2)%qsws(m) )                                 &
-                                           * heatflux_output_conversion(nzt)
-                   ENDIF
-                   IF ( bulk_cloud_model )  THEN
+                sums_l(nzb,12,tn) = sums_l(nzb,12,tn) + &
+                                    usws(j,i) * rmask(j,i,sr)     ! w"u"
+                sums_l(nzb,14,tn) = sums_l(nzb,14,tn) + &
+                                    vsws(j,i) * rmask(j,i,sr)     ! w"v"
+                sums_l(nzb,16,tn) = sums_l(nzb,16,tn) + &
+                                    shf(j,i)  * rmask(j,i,sr)     ! w"pt"
+                sums_l(nzb,58,tn) = sums_l(nzb,58,tn) + &
+                                    0.0 * rmask(j,i,sr)           ! u"pt"
+                sums_l(nzb,61,tn) = sums_l(nzb,61,tn) + &
+                                    0.0 * rmask(j,i,sr)           ! v"pt"
+                IF ( moisture )  THEN
+                   sums_l(nzb,48,tn) = sums_l(nzb,48,tn) + &
+                                       qsws(j,i) * rmask(j,i,sr)  ! w"q" (w"qv")
+                   IF ( cloud_physics )  THEN
+                      sums_l(nzb,45,tn) = sums_l(nzb,45,tn) + (           &
+                                          ( 1.0 + 0.61 * q(nzb,j,i) ) *   &
+                                          shf(j,i) + 0.61 * pt(nzb,j,i) * &
+                                                     qsws(j,i)            &
+                                                              )
 !
 !--                   Formula does not work if ql(nzb) /= 0.0
-                      sums_l(nzt,51,tn) = sums_l(nzt,51,tn) +              &  ! w"q" (w"qv")
-                                          waterflux_output_conversion(nzt) *                       &
-                                          surf_def_h(2)%qsws(m) * rmask(j,i,sr)
+                      sums_l(nzb,51,tn) = sums_l(nzb,51,tn) + &   ! w"q" (w"qv")
+                                          qsws(j,i) * rmask(j,i,sr)
                    ENDIF
                 ENDIF
                 IF ( passive_scalar )  THEN
-                   sums_l(nzt,117,tn) = sums_l(nzt,117,tn) +                                       &
-                                        surf_def_h(2)%ssws(m) * rmask(j,i,sr) ! w"s"
+                   sums_l(nzb,48,tn) = sums_l(nzb,48,tn) + &
+                                       qsws(j,i) * rmask(j,i,sr)  ! w"q" (w"qv")
                 ENDIF
-#endif
              ENDIF
 
 !
 !--          Resolved fluxes (can be computed for all horizontal points)
-!--          NOTE: for simplicity, nzb_s_inner is used below, although strictly speaking the
-!--          ----  following k-loop would have to be split up and rearranged according to the
-!--                staggered grid.
-             DO  k = nzb, nzt
-                flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 22 ) )
-                ust = 0.5_wp * ( u(k,j,i)   - hom(k,1,1,sr) +                                      &
-                                 u(k+1,j,i) - hom(k+1,1,1,sr) )
-                vst = 0.5_wp * ( v(k,j,i)   - hom(k,1,2,sr) +                                      &
-                                 v(k+1,j,i) - hom(k+1,1,2,sr) )
-                pts = 0.5_wp * ( pt(k,j,i)   - hom(k,1,4,sr) +                                     &
-                                 pt(k+1,j,i) - hom(k+1,1,4,sr) )
+!--          NOTE: for simplicity, nzb_s_outer is used below, although strictly 
+!--          ----  speaking the following k-loop would have to be split up and 
+!--                rearranged according to the staggered grid.
+             DO  k = nzb_s_outer(j,i), nzt
+                ust = 0.5 * ( u(k,j,i)   - hom(k,1,1,sr) + &
+                              u(k+1,j,i) - hom(k+1,1,1,sr) )
+                vst = 0.5 * ( v(k,j,i)   - hom(k,1,2,sr) + &
+                              v(k+1,j,i) - hom(k+1,1,2,sr) )
+                pts = 0.5 * ( pt(k,j,i)   - hom(k,1,4,sr) + &
+                              pt(k+1,j,i) - hom(k+1,1,4,sr) )
+!
+!--             Momentum flux w*u*
+                sums_l(k,13,tn) = sums_l(k,13,tn) + 0.5 *                     &
+                                                    ( w(k,j,i-1) + w(k,j,i) ) &
+                                                    * ust * rmask(j,i,sr)
+!
+!--             Momentum flux w*v*
+                sums_l(k,15,tn) = sums_l(k,15,tn) + 0.5 *                     &
+                                                    ( w(k,j-1,i) + w(k,j,i) ) &
+                                                    * vst * rmask(j,i,sr)
+!
+!--             Heat flux w*pt*
+!--             The following formula (comment line, not executed) does not
+!--             work if applied to subregions
+!                sums_l(k,17,tn) = sums_l(k,17,tn) + 0.5 *                     &
+!                                                    ( pt(k,j,i)+pt(k+1,j,i) ) &
+!                                                    * w(k,j,i) * rmask(j,i,sr)
+                sums_l(k,17,tn) = sums_l(k,17,tn) + pts * w(k,j,i) * &
+                                                    rmask(j,i,sr)
 !
 !--             Higher moments
-                !$ACC ATOMIC
-                sums_l(k,35,tn) = sums_l(k,35,tn) + pts * w(k,j,i)**2 * rmask(j,i,sr) * flag
-                !$ACC ATOMIC
-                sums_l(k,36,tn) = sums_l(k,36,tn) + pts**2 * w(k,j,i) * rmask(j,i,sr) * flag
-
-!
-!--             Salinity flux and density (density does not belong to here, but so far there is no
-!--             other suitable place to calculate)
-#ifndef _OPENACC
-                IF ( ocean_mode )  THEN
-                   IF( .NOT. ws_scheme_sca .OR. sr /= 0 )  THEN
-                      pts = 0.5_wp * ( sa(k,j,i)   - hom(k,1,23,sr) +                              &
-                                       sa(k+1,j,i) - hom(k+1,1,23,sr) )
-                      sums_l(k,66,tn) = sums_l(k,66,tn) + pts * w(k,j,i) *                         &
-                                        rmask(j,i,sr) * flag
+                sums_l(k,35,tn) = sums_l(k,35,tn) + pts * w(k,j,i)**2 * &
+                                                    rmask(j,i,sr)
+                sums_l(k,36,tn) = sums_l(k,36,tn) + pts**2 * w(k,j,i) * &
+                                                    rmask(j,i,sr)
+
+!
+!--             Buoyancy flux, water flux, humidity flux and liquid water
+!--             content
+                IF ( moisture )  THEN
+                   pts = 0.5 * ( vpt(k,j,i)   - hom(k,1,44,sr) + &
+                                 vpt(k+1,j,i) - hom(k+1,1,44,sr) )
+                   sums_l(k,46,tn) = sums_l(k,46,tn) + pts * w(k,j,i) * &
+                                                       rmask(j,i,sr)
+                   pts = 0.5 * ( q(k,j,i)   - hom(k,1,41,sr) + &
+                                 q(k+1,j,i) - hom(k+1,1,41,sr) )
+                   sums_l(k,49,tn) = sums_l(k,49,tn) + pts * w(k,j,i) * &
+                                                       rmask(j,i,sr)
+                   IF ( cloud_physics  .OR.  cloud_droplets )  THEN
+                      pts = 0.5 *                                            &
+                             ( ( q(k,j,i)   - ql(k,j,i)   ) - hom(k,1,42,sr) &
+                             + ( q(k+1,j,i) - ql(k+1,j,i) ) - hom(k+1,1,42,sr) )
+                      sums_l(k,52,tn) = sums_l(k,52,tn) + pts * w(k,j,i) * &
+                                                          rmask(j,i,sr)
+                      sums_l(k,54,tn) = sums_l(k,54,tn) + ql(k,j,i) * &
+                                                          rmask(j,i,sr)
                    ENDIF
-                   sums_l(k,64,tn) = sums_l(k,64,tn) + rho_ocean(k,j,i) * rmask(j,i,sr) * flag
-                   sums_l(k,71,tn) = sums_l(k,71,tn) + prho(k,j,i)      * rmask(j,i,sr) * flag
                 ENDIF
 
 !
-!--             Buoyancy flux, water flux, humidity flux, liquid water content, rain drop
-!--             concentration and rain water content
-                IF ( humidity )  THEN
-                   IF ( bulk_cloud_model  .OR.  cloud_droplets )  THEN
-                      pts = 0.5_wp * ( vpt(k,j,i)   - hom(k,1,44,sr) +                             &
-                                       vpt(k+1,j,i) - hom(k+1,1,44,sr) )
-                      sums_l(k,46,tn) = sums_l(k,46,tn) + pts * w(k,j,i) *                         &
-                                                          rho_air_zw(k) *                          &
-                                                          heatflux_output_conversion(k) *          &
-                                                          rmask(j,i,sr) * flag
-                      sums_l(k,54,tn) = sums_l(k,54,tn) + ql(k,j,i) * rmask(j,i,sr) * flag
-
-                      IF ( .NOT. cloud_droplets )  THEN
-                         pts = 0.5_wp *                                                            &
-                               ( ( q(k,j,i) - ql(k,j,i) ) -                                        &
-                               hom(k,1,42,sr) +                                                    &
-                               ( q(k+1,j,i) - ql(k+1,j,i) ) -                                      &
-                               hom(k+1,1,42,sr) )
-                         sums_l(k,52,tn) = sums_l(k,52,tn) + pts * w(k,j,i) *                      &
-                                             rho_air_zw(k) *                                       &
-                                             waterflux_output_conversion(k) *                      &
-                                             rmask(j,i,sr) * flag
-                         sums_l(k,75,tn) = sums_l(k,75,tn) + qc(k,j,i)  * rmask(j,i,sr) * flag
-                         sums_l(k,76,tn) = sums_l(k,76,tn) + prr(k,j,i) * rmask(j,i,sr) * flag
-                         IF ( microphysics_morrison )  THEN
-                            sums_l(k,123,tn) = sums_l(k,123,tn) + nc(k,j,i) * rmask(j,i,sr) * flag
-                         ENDIF
-                         IF ( microphysics_ice_phase )  THEN
-                            sums_l(k,124,tn) = sums_l(k,124,tn) + ni(k,j,i) * rmask(j,i,sr) * flag
-                            sums_l(k,125,tn) = sums_l(k,125,tn) + qi(k,j,i) * rmask(j,i,sr) * flag
-                            IF ( graupel  .AND.  snow )  THEN
-                               sums_l(k,126,tn) = sums_l(k,126,tn) + ng(k,j,i) * rmask(j,i,sr) * flag
-                               sums_l(k,127,tn) = sums_l(k,127,tn) + qg(k,j,i) * rmask(j,i,sr) * flag
-                               sums_l(k,128,tn) = sums_l(k,128,tn) + ns(k,j,i) * rmask(j,i,sr) * flag
-                               sums_l(k,129,tn) = sums_l(k,129,tn) + qs(k,j,i) * rmask(j,i,sr) * flag
-                            ENDIF
-                         ENDIF
-
-                         IF ( microphysics_seifert )  THEN
-                            sums_l(k,73,tn) = sums_l(k,73,tn) + nr(k,j,i) * rmask(j,i,sr) * flag
-                            sums_l(k,74,tn) = sums_l(k,74,tn) + qr(k,j,i) * rmask(j,i,sr) * flag
-                         ENDIF
-                      ENDIF
-
-                   ELSE
-                      IF( .NOT. ws_scheme_sca  .OR.  sr /= 0 )  THEN
-                         pts = 0.5_wp * ( vpt(k,j,i)   - hom(k,1,44,sr) +                          &
-                                          vpt(k+1,j,i) - hom(k+1,1,44,sr) )
-                         sums_l(k,46,tn) = sums_l(k,46,tn) + pts * w(k,j,i) *                      &
-                                                             rho_air_zw(k)  *                      &
-                                                             heatflux_output_conversion(k) *       &
-                                                             rmask(j,i,sr)  * flag
-                      ELSE IF ( ws_scheme_sca  .AND.  sr == 0 )  THEN
-                         sums_l(k,46,tn) = ( ( 1.0_wp + 0.61_wp *                                  &
-                                               hom(k,1,41,sr) ) *                                  &
-                                             sums_l(k,17,tn) +                                     &
-                                             0.61_wp * hom(k,1,4,sr) *                             &
-                                             sums_l(k,49,tn)                                       &
-                                           ) * heatflux_output_conversion(k) * flag
-                      END IF
-                   END IF
-                   temp = exner(k) * pt(k,j,i)
-                   e_s = magnus( temp )
-                   q_s = rd_d_rv * e_s / ( hyp(k) - e_s )
-                   rh_tmp = q(k,j,i) / q_s * 100.0_wp
-                   sums_l(k,130,tn) = sums_l(k,130,tn) + rh_tmp * rmask(j,i,sr) * flag
+!--             Passive scalar flux
+                IF ( passive_scalar )  THEN
+                   pts = 0.5 * ( q(k,j,i)   - hom(k,1,41,sr) + &
+                                 q(k+1,j,i) - hom(k+1,1,41,sr) )
+                   sums_l(k,49,tn) = sums_l(k,49,tn) + pts * w(k,j,i) * &
+                                                       rmask(j,i,sr)
                 ENDIF
-!
-!--             Passive scalar flux
-                IF ( passive_scalar  .AND.  ( .NOT. ws_scheme_sca .OR. sr /= 0 ) )  THEN
-                   pts = 0.5_wp * ( s(k,j,i)   - hom(k,1,115,sr) +                                 &
-                                    s(k+1,j,i) - hom(k+1,1,115,sr) )
-                   sums_l(k,114,tn) = sums_l(k,114,tn) + pts * w(k,j,i) * rmask(j,i,sr) * flag
-                ENDIF
-#endif
 
 !
 !--             Energy flux w*e*
-!--             has to be adjusted
-                !$ACC ATOMIC
-                sums_l(k,37,tn) = sums_l(k,37,tn) + w(k,j,i) * 0.5_wp *                            &
-                                                    ( ust**2 + vst**2 + w(k,j,i)**2 )              &
-                                                    * rho_air_zw(k)                                &
-                                                    * momentumflux_output_conversion(k)            &
-                                                    * rmask(j,i,sr) * flag
+                sums_l(k,37,tn) = sums_l(k,37,tn) + w(k,j,i) * 0.5 *           &
+                                              ( ust**2 + vst**2 + w(k,j,i)**2 )&
+                                              * rmask(j,i,sr)
+          
              ENDDO
           ENDDO
        ENDDO
-       !$OMP END PARALLEL
-
-       !$ACC UPDATE &
-       !$ACC HOST(sums_l(:,12,tn), sums_l(:,14,tn), sums_l(:,16,tn)) &
-       !$ACC HOST(sums_l(:,35,tn), sums_l(:,36,tn), sums_l(:,37,tn))
-!
-!--    Treat land-surface quantities according to new wall model structure.
-       IF ( land_surface )  THEN
-          tn = 0
-          !$OMP PARALLEL PRIVATE( i, j, m, tn )
-          !$ tn = omp_get_thread_num()
-          !$OMP DO
-          DO  m = 1, surf_lsm_h(0)%ns
-             i = surf_lsm_h(0)%i(m)
-             j = surf_lsm_h(0)%j(m)
-
-             sums_l(nzb,93,tn)  = sums_l(nzb,93,tn) + surf_lsm_h(0)%ghf(m)       * rmask(j,i,sr)
-             sums_l(nzb,94,tn)  = sums_l(nzb,94,tn) + surf_lsm_h(0)%qsws_liq(m)  * rmask(j,i,sr)
-             sums_l(nzb,95,tn)  = sums_l(nzb,95,tn) + surf_lsm_h(0)%qsws_soil(m) * rmask(j,i,sr)
-             sums_l(nzb,96,tn)  = sums_l(nzb,96,tn) + surf_lsm_h(0)%qsws_veg(m)  * rmask(j,i,sr)
-             sums_l(nzb,97,tn)  = sums_l(nzb,97,tn) + surf_lsm_h(0)%r_a(m)       * rmask(j,i,sr)
-             sums_l(nzb,98,tn)  = sums_l(nzb,98,tn) + surf_lsm_h(0)%r_s(m)       * rmask(j,i,sr)
-          ENDDO
-          !$OMP END PARALLEL
-
-          tn = 0
-          !$OMP PARALLEL PRIVATE( i, j, k, m, tn )
-          !$ tn = omp_get_thread_num()
-          !$OMP DO
-          DO  m = 1, surf_lsm_h(0)%ns
-
-             i = surf_lsm_h(0)%i(m)
-             j = surf_lsm_h(0)%j(m)
-             DO  k = nzb_soil, nzt_soil
-                sums_l(k,89,tn)  = sums_l(k,89,tn)  + t_soil_h(0)%var_2d(k,m) * rmask(j,i,sr)
-                sums_l(k,91,tn)  = sums_l(k,91,tn)  + m_soil_h(0)%var_2d(k,m) * rmask(j,i,sr)
-             ENDDO
-          ENDDO
-          !$OMP END PARALLEL
-       ENDIF
-!
-!--    Treat urban-surface quantities according to new wall model structure. Here, ghf and r_a are
-!--    added on top of LSM sums.
-       IF ( land_surface  .AND.  urban_surface )  THEN
-          tn = 0
-          !$OMP PARALLEL PRIVATE( i, j, m, tn )
-          !$ tn = omp_get_thread_num()
-          !$OMP DO
-          DO  m = 1, surf_usm_h(0)%ns
-             i = surf_usm_h(0)%i(m)
-             j = surf_usm_h(0)%j(m)
-
-             sums_l(nzb,93,tn)  = sums_l(nzb,93,tn) + surf_usm_h(0)%wghf_eb(m) * rmask(j,i,sr)
-             sums_l(nzb,97,tn)  = sums_l(nzb,97,tn) + surf_usm_h(0)%r_a(m)     * rmask(j,i,sr)
-          ENDDO
-          !$OMP END PARALLEL
-       ENDIF
-!
-!--    For speed optimization fluxes which have been computed in part directly inside the WS
-!--    advection routines are treated seperatly.
-!--    Momentum fluxes first:
-
-       tn = 0
-       !$OMP PARALLEL PRIVATE( i, j, k, tn, flag )
-       !$ tn = omp_get_thread_num()
-       IF ( .NOT. ws_scheme_mom .OR. sr /= 0  )  THEN
+
+!
+!--    Divergence of vertical flux of resolved scale energy and pressure
+!--    fluctuations. First calculate the products, then the divergence.
+!--    Calculation is time consuming. Do it only, if profiles shall be plotted.
+       IF ( hom(nzb+1,2,55,0) /= 0.0 )  THEN
+
+          sums_ll = 0.0  ! local array
+
           !$OMP DO
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb, nzt
-!
-!--                Flag 23 is used to mask surface fluxes as well as model-top fluxes, which are
-!--                added further below.
-                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 23 ) ) *        &
-                          MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 9  ) )
-
-                   ust = 0.5_wp * ( u(k,j,i)   - hom(k,1,1,sr) +                                   &
-                                    u(k+1,j,i) - hom(k+1,1,1,sr) )
-                   vst = 0.5_wp * ( v(k,j,i)   - hom(k,1,2,sr) +                                   &
-                                    v(k+1,j,i) - hom(k+1,1,2,sr) )
-!
-!--                Momentum flux w*u*
-                   sums_l(k,13,tn) = sums_l(k,13,tn) + 0.5_wp *                                    &
-                                                     ( w(k,j,i-1) + w(k,j,i) )                     &
-                                                     * rho_air_zw(k)                               &
-                                                     * momentumflux_output_conversion(k)           &
-                                                     * ust * rmask(j,i,sr)                         &
-                                                           * flag
-!
-!--                Momentum flux w*v*
-                   sums_l(k,15,tn) = sums_l(k,15,tn) + 0.5_wp * ( w(k,j-1,i) + w(k,j,i) )          &
-                                                     * rho_air_zw(k)                               &
-                                                     * momentumflux_output_conversion(k)           &
-                                                     * vst * rmask(j,i,sr)                         &
-                                                           * flag
+                DO  k = nzb_s_outer(j,i)+1, nzt
+
+                   sums_ll(k,1) = sums_ll(k,1) + 0.5 * w(k,j,i) * (        &
+                  ( 0.25 * ( u(k,j,i)+u(k+1,j,i)+u(k,j,i+1)+u(k+1,j,i+1)   &
+                           - 2.0 * ( hom(k,1,1,sr) + hom(k+1,1,1,sr) )     &
+                           ) )**2                                          &
+                + ( 0.25 * ( v(k,j,i)+v(k+1,j,i)+v(k,j+1,i)+v(k+1,j+1,i)   &
+                           - 2.0 * ( hom(k,1,2,sr) + hom(k+1,1,2,sr) )     &
+                           ) )**2                                          &
+                   + w(k,j,i)**2                                  )
+
+                   sums_ll(k,2) = sums_ll(k,2) + 0.5 * w(k,j,i) &
+                                               * ( p(k,j,i) + p(k+1,j,i) )
+
                 ENDDO
              ENDDO
           ENDDO
-
-       ENDIF
-       IF ( .NOT. ws_scheme_sca .OR. sr /= 0 )  THEN
+          sums_ll(0,1)     = 0.0    ! because w is zero at the bottom
+          sums_ll(nzt+1,1) = 0.0
+          sums_ll(0,2)     = 0.0
+          sums_ll(nzt+1,2) = 0.0
+
+          DO  k = nzb_s_outer(j,i)+1, nzt
+             sums_l(k,55,tn) = ( sums_ll(k,1) - sums_ll(k-1,1) ) * ddzw(k)
+             sums_l(k,56,tn) = ( sums_ll(k,2) - sums_ll(k-1,2) ) * ddzw(k)
+          ENDDO
+          sums_l(nzb,55,tn) = sums_l(nzb+1,55,tn)
+          sums_l(nzb,56,tn) = sums_l(nzb+1,56,tn)
+
+       ENDIF
+
+!
+!--    Divergence of vertical flux of SGS TKE
+       IF ( hom(nzb+1,2,57,0) /= 0.0 )  THEN
+
           !$OMP DO
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb, nzt
-                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 23 ) ) *        &
-                          MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 9  ) )
-!
-!--                Vertical heat flux
-                   sums_l(k,17,tn) = sums_l(k,17,tn) + 0.5_wp *                                    &
-                                     ( pt(k,j,i)   - hom(k,1,4,sr) +                               &
-                                       pt(k+1,j,i) - hom(k+1,1,4,sr) )                             &
-                                     * rho_air_zw(k)                                               &
-                                     * heatflux_output_conversion(k)                               &
-                                     * w(k,j,i) * rmask(j,i,sr) * flag
-                   IF ( humidity )  THEN
-                      pts = 0.5_wp * ( q(k,j,i)   - hom(k,1,41,sr) +                               &
-                                       q(k+1,j,i) - hom(k+1,1,41,sr) )
-                      sums_l(k,49,tn) = sums_l(k,49,tn) + pts * w(k,j,i) *                         &
-                                                          rho_air_zw(k)  *                         &
-                                                          waterflux_output_conversion(k) *         &
-                                                          rmask(j,i,sr)  * flag
-                   ENDIF
-                   IF ( passive_scalar )  THEN
-                      pts = 0.5_wp * ( s(k,j,i)   - hom(k,1,115,sr) +                              &
-                                       s(k+1,j,i) - hom(k+1,1,115,sr) )
-                      sums_l(k,114,tn) = sums_l(k,114,tn) + pts * w(k,j,i) *  rmask(j,i,sr) * flag
-                   ENDIF
+                DO  k = nzb_s_outer(j,i)+1, nzt
+
+                   sums_l(k,57,tn) = sums_l(k,57,tn) + (                       &
+                   (km(k,j,i)+km(k+1,j,i)) * (e(k+1,j,i)-e(k,j,i)) * ddzu(k+1) &
+                 - (km(k-1,j,i)+km(k,j,i)) * (e(k,j,i)-e(k-1,j,i)) * ddzu(k)   &
+                                                 ) * ddzw(k)
+
                 ENDDO
              ENDDO
           ENDDO
-
-       ENDIF
-
-!
-!--    Density at top follows Neumann condition
-       IF ( ocean_mode )  THEN
-          sums_l(nzt+1,64,tn) = sums_l(nzt,64,tn)
-          sums_l(nzt+1,71,tn) = sums_l(nzt,71,tn)
-       ENDIF
-
-!
-!--    Divergence of vertical flux of resolved scale energy and pressure fluctuations as well as
-!--    flux of pressure fluctuation itself (68).
-!--    First calculate the products, then the divergence.
-!--    Calculation is time consuming. Do it only, if profiles shall be plotted.
-       IF ( hom(nzb+1,2,55,0) /= 0.0_wp  .OR.  hom(nzb+1,2,68,0) /= 0.0_wp )  THEN
-          sums_ll = 0.0_wp  ! local array
+          sums_l(nzb,57,tn) = sums_l(nzb+1,57,tn)
+
+       ENDIF
+
+!
+!--    Horizontal heat fluxes (subgrid, resolved, total). 
+!--    Do it only, if profiles shall be plotted. 
+       IF ( hom(nzb+1,2,58,0) /= 0.0 ) THEN
 
           !$OMP DO
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb+1, nzt
-                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
-
-                   sums_ll(k,1) = sums_ll(k,1) + 0.5_wp * w(k,j,i) * (                             &
-                                    ( 0.25_wp * ( u(k,j,i)+u(k+1,j,i)+u(k,j,i+1)+u(k+1,j,i+1) )    &
-                                              - 0.5_wp * ( hom(k,1,1,sr) + hom(k+1,1,1,sr) ) )**2  &
-                                  + ( 0.25_wp * ( v(k,j,i)+v(k+1,j,i)+v(k,j+1,i)+v(k+1,j+1,i) )    &
-                                              - 0.5_wp * ( hom(k,1,2,sr) + hom(k+1,1,2,sr) ) )**2  &
-                                  + w(k,j,i)**2                      ) * flag * rmask(j,i,sr)
-
-                   sums_ll(k,2) = sums_ll(k,2) + 0.5_wp * w(k,j,i)                                 &
-                                       * ( ( p(k,j,i) + p(k+1,j,i) )                               &
-                                         / momentumflux_output_conversion(k) )                     &
-                                       * flag * rmask(j,i,sr)
-
+                DO  k = nzb_s_outer(j,i)+1, nzt
+!
+!--                Subgrid horizontal heat fluxes u"pt", v"pt"
+                   sums_l(k,58,tn) = sums_l(k,58,tn) - 0.5 *                   &
+                                                   ( kh(k,j,i) + kh(k,j,i-1) ) &
+                                                 * ( pt(k,j,i-1) - pt(k,j,i) ) &
+                                                 * ddx * rmask(j,i,sr)
+                   sums_l(k,61,tn) = sums_l(k,61,tn) - 0.5 *                   &
+                                                   ( kh(k,j,i) + kh(k,j-1,i) ) &
+                                                 * ( pt(k,j-1,i) - pt(k,j,i) ) &
+                                                 * ddy * rmask(j,i,sr)
+!
+!--                Resolved horizontal heat fluxes u*pt*, v*pt*
+                   sums_l(k,59,tn) = sums_l(k,59,tn) +                         &
+                                                  ( u(k,j,i) - hom(k,1,1,sr) ) &
+                                       * 0.5 * ( pt(k,j,i-1) - hom(k,1,4,sr) + &
+                                                 pt(k,j,i)   - hom(k,1,4,sr) )
+                   pts = 0.5 * ( pt(k,j-1,i) - hom(k,1,4,sr) + &
+                                 pt(k,j,i)   - hom(k,1,4,sr) )
+                   sums_l(k,62,tn) = sums_l(k,62,tn) +                         &
+                                                  ( v(k,j,i) - hom(k,1,2,sr) ) &
+                                       * 0.5 * ( pt(k,j-1,i) - hom(k,1,4,sr) + &
+                                                 pt(k,j,i)   - hom(k,1,4,sr) )
                 ENDDO
              ENDDO
           ENDDO
-          sums_ll(0,1)     = 0.0_wp    ! because w is zero at the bottom
-          sums_ll(nzt+1,1) = 0.0_wp
-          sums_ll(0,2)     = 0.0_wp
-          sums_ll(nzt+1,2) = 0.0_wp
-
-          DO  k = nzb+1, nzt
-             sums_l(k,55,tn) = ( sums_ll(k,1) - sums_ll(k-1,1) ) * ddzw(k)
-             sums_l(k,56,tn) = ( sums_ll(k,2) - sums_ll(k-1,2) ) * ddzw(k)
-             sums_l(k,68,tn) = sums_ll(k,2)
-          ENDDO
-          sums_l(nzb,55,tn) = sums_l(nzb+1,55,tn)
-          sums_l(nzb,56,tn) = sums_l(nzb+1,56,tn)
-          sums_l(nzb,68,tn) = 0.0_wp    ! because w* = 0 at nzb
-
-       ENDIF
-
-!
-!--    Divergence of vertical flux of SGS TKE and the flux itself (69)
-       IF ( hom(nzb+1,2,57,0) /= 0.0_wp  .OR.  hom(nzb+1,2,69,0) /= 0.0_wp )  THEN
-          !$OMP DO
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb+1, nzt
-
-                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
-
-                   sums_l(k,57,tn) = sums_l(k,57,tn) - 0.5_wp * (                                  &
-                                       (km(k,j,i)+km(k+1,j,i)) * (e(k+1,j,i)-e(k,j,i)) * ddzu(k+1) &
-                                     - (km(k-1,j,i)+km(k,j,i)) * (e(k,j,i)-e(k-1,j,i)) * ddzu(k)   &
-                                                                ) * ddzw(k)                        &
-                                                                  * flag * rmask(j,i,sr)
-
-                   sums_l(k,69,tn) = sums_l(k,69,tn) - 0.5_wp * (                                  &
-                                        ( km(k,j,i) + km(k+1,j,i) ) *                              &
-                                        ( e(k+1,j,i) - e(k,j,i) ) * ddzu(k+1)                      &
-                                                                ) * flag * rmask(j,i,sr)
-
-                ENDDO
-             ENDDO
-          ENDDO
-          sums_l(nzb,57,tn) = sums_l(nzb+1,57,tn)
-          sums_l(nzb,69,tn) = sums_l(nzb+1,69,tn)
-
-       ENDIF
-
-!
-!--    Horizontal heat fluxes (subgrid, resolved, total).
-!--    Do it only, if profiles shall be plotted.
-       IF ( hom(nzb+1,2,58,0) /= 0.0_wp ) THEN
-
-          !$OMP DO
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb+1, nzt
-                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
-!
-!--                Subgrid horizontal heat fluxes u"pt", v"pt"
-                   sums_l(k,58,tn) = sums_l(k,58,tn) - 0.5_wp *                                    &
-                                                        ( kh(k,j,i) + kh(k,j,i-1) )                &
-                                                      * ( pt(k,j,i-1) - pt(k,j,i) )                &
-                                                      * rho_air_zw(k)                              &
-                                                      * heatflux_output_conversion(k)              &
-                                                      * ddx * rmask(j,i,sr) * flag
-                   sums_l(k,61,tn) = sums_l(k,61,tn) - 0.5_wp *                                    &
-                                                        ( kh(k,j,i) + kh(k,j-1,i) )                &
-                                                      * ( pt(k,j-1,i) - pt(k,j,i) )                &
-                                                      * rho_air_zw(k)                              &
-                                                      * heatflux_output_conversion(k)              &
-                                                      * ddy * rmask(j,i,sr) * flag
-!
-!--                Resolved horizontal heat fluxes u*pt*, v*pt*
-                   sums_l(k,59,tn) = sums_l(k,59,tn) +              ( u(k,j,i) - hom(k,1,1,sr) )   &
-                                                      * 0.5_wp * ( pt(k,j,i-1) - hom(k,1,4,sr) +   &
-                                                                   pt(k,j,i)   - hom(k,1,4,sr) )   &
-                                                                 * heatflux_output_conversion(k)   &
-                                                                 * flag
-                   pts = 0.5_wp * ( pt(k,j-1,i) - hom(k,1,4,sr) +                                  &
-                                    pt(k,j,i)   - hom(k,1,4,sr) )
-                   sums_l(k,62,tn) = sums_l(k,62,tn) +              ( v(k,j,i) - hom(k,1,2,sr) )   &
-                                                      * 0.5_wp * ( pt(k,j-1,i) - hom(k,1,4,sr) +   &
-                                                                   pt(k,j,i)   - hom(k,1,4,sr) )   &
-                                                                 * heatflux_output_conversion(k)   &
-                                                                 * flag
-                ENDDO
-             ENDDO
-          ENDDO
 !
 !--       Fluxes at the surface must be zero (e.g. due to the Prandtl-layer)
-          sums_l(nzb,58,tn) = 0.0_wp
-          sums_l(nzb,59,tn) = 0.0_wp
-          sums_l(nzb,60,tn) = 0.0_wp
-          sums_l(nzb,61,tn) = 0.0_wp
-          sums_l(nzb,62,tn) = 0.0_wp
-          sums_l(nzb,63,tn) = 0.0_wp
-
-       ENDIF
-       !$OMP END PARALLEL
-
-!
-!--    Collect current large scale advection and subsidence tendencies for
-!--    data output
-       IF ( large_scale_forcing  .AND.  ( simulated_time > 0.0_wp ) )  THEN
-!
-!--       Interpolation in time of LSF_DATA
-          nt = 1
-          DO WHILE ( simulated_time - dt_3d > time_vert(nt) )
-             nt = nt + 1
-          ENDDO
-          IF ( simulated_time - dt_3d /= time_vert(nt) )  THEN
-            nt = nt - 1
-          ENDIF
-
-          fac = ( simulated_time - dt_3d - time_vert(nt) ) / ( time_vert(nt+1)-time_vert(nt) )
-
-
-          DO  k = nzb, nzt
-             sums_ls_l(k,0) = td_lsa_lpt(k,nt) + fac * ( td_lsa_lpt(k,nt+1) - td_lsa_lpt(k,nt) )
-             sums_ls_l(k,1) = td_lsa_q(k,nt)   + fac * ( td_lsa_q(k,nt+1)   - td_lsa_q(k,nt) )
-          ENDDO
-
-          sums_ls_l(nzt+1,0) = sums_ls_l(nzt,0)
-          sums_ls_l(nzt+1,1) = sums_ls_l(nzt,1)
-
-          IF ( large_scale_subsidence  .AND.  use_subsidence_tendencies )  THEN
-
-             DO  k = nzb, nzt
-                sums_ls_l(k,2) = td_sub_lpt(k,nt) + fac * ( td_sub_lpt(k,nt+1) - td_sub_lpt(k,nt) )
-                sums_ls_l(k,3) = td_sub_q(k,nt)   + fac * ( td_sub_q(k,nt+1)   - td_sub_q(k,nt) )
-             ENDDO
-
-             sums_ls_l(nzt+1,2) = sums_ls_l(nzt,2)
-             sums_ls_l(nzt+1,3) = sums_ls_l(nzt,3)
-
-          ENDIF
-
-       ENDIF
-
-       tn = 0
-       !$OMP PARALLEL PRIVATE( i, j, k, tn )
-       !$ tn = omp_get_thread_num()
-       IF ( radiation  .AND.  radiation_scheme == 'rrtmg' )  THEN
-          !$OMP DO
-          DO  i = nxl, nxr
-             DO  j =  nys, nyn
-                DO  k = nzb+1, nzt+1
-                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
-
-                   sums_l(k,100,tn)  = sums_l(k,100,tn) + rad_lw_in(k,j,i)    * rmask(j,i,sr) * flag
-                   sums_l(k,101,tn)  = sums_l(k,101,tn) + rad_lw_out(k,j,i)   * rmask(j,i,sr) * flag
-                   sums_l(k,102,tn)  = sums_l(k,102,tn) + rad_sw_in(k,j,i)    * rmask(j,i,sr) * flag
-                   sums_l(k,103,tn)  = sums_l(k,103,tn) + rad_sw_out(k,j,i)   * rmask(j,i,sr) * flag
-                   sums_l(k,104,tn)  = sums_l(k,104,tn) + rad_lw_cs_hr(k,j,i) * rmask(j,i,sr) * flag
-                   sums_l(k,105,tn)  = sums_l(k,105,tn) + rad_lw_hr(k,j,i)    * rmask(j,i,sr) * flag
-                   sums_l(k,106,tn)  = sums_l(k,106,tn) + rad_sw_cs_hr(k,j,i) * rmask(j,i,sr) * flag
-                   sums_l(k,107,tn)  = sums_l(k,107,tn) + rad_sw_hr(k,j,i)    * rmask(j,i,sr) * flag
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-
-!
-!--    Calculate the profiles for all other modules
-       CALL module_interface_statistics( 'profiles', sr, tn, dots_max )
+          sums(nzb,58) = 0.0
+          sums(nzb,59) = 0.0
+          sums(nzb,60) = 0.0
+          sums(nzb,61) = 0.0
+          sums(nzb,62) = 0.0
+          sums(nzb,63) = 0.0
+
+       ENDIF
        !$OMP END PARALLEL
 
